package routes

import (
	"git.matterlinux.xyz/matter/security/lib"
	"git.matterlinux.xyz/matter/security/log"
	"github.com/gofiber/fiber/v2"
)

func POST_Login(c *fiber.Ctx) error {
	body := struct {
		Username string `form:"username"`
		Password string `form:"password"`
	}{}

	err := c.BodyParser(&body)
	if err != nil {
		return lib.RenderError(c, 400)
	}

	users, err := lib.LoadUsers()
	if err != nil {
		log.Error("Failed to load users: %s", err.Error())
		return lib.RenderError(c, 500)
	}

	for _, u := range users {
		if u.Username == u.Username &&
			u.Password == lib.GetSHA256([]byte(body.Password)) {
			u.Cookie = lib.GetRandom()
			c.Cookie(&fiber.Cookie{
				Name:  "auth",
				Value: u.Cookie,
			})
			err = lib.UpdateUser(u)
			if err != nil {
				log.Error("Failed to update user: %s", err.Error())
				return lib.RenderError(c, 500)
			}
			return c.Redirect("/manage")
		}
	}

	c.Status(403)
	return c.Render("login", fiber.Map{})
}

func GET_Login(c *fiber.Ctx) error {
	if c.Cookies("auth") != "" {
		return c.Redirect("/manage")
	}

	return c.Render("login", fiber.Map{})
}
